use crate::*;

#[tokio::test]
async fn run() {
    let mut context = Context::new();

    context.add_dependency(Dependency::new::<A>());
}

struct A {}

impl System for A {
    const DEPENDENCIES: Dependencies = &[
        &Dependency::new::<B>()
    ];

    const EVENT_HANDLERS: EventHandlers = &[];

    fn new(ctx: ContextHandle) -> Self {
        println!("Creating A");

        Self {

        }
    }

    fn start(&mut self) {
        println!("Starting A");
    }
}
struct B {}

impl System for B {
    const DEPENDENCIES: Dependencies = &[];

    const EVENT_HANDLERS: EventHandlers = &[];

    fn new(ctx: ContextHandle) -> Self {
        println!("Creating B");

        Self {

        }
    }

    fn start(&mut self) {
        println!("Starting B");
    }
}